#include "Appevent.ch"
#include "Common.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "xbpdev.ch"

CLASS XbpPreview FROM xbpStatic
  EXPORTED:
	VAR anzeigseite								 // aktuelle Seitennumer

	PROTECTED:
	VAR oView                      // xbpDialog als Anzeigebereich
	VAR oSquare                    // xbpStatic zum Fllen der Lcke zw. Scrollbars
	VAR oPresSpace                 // XbpPresSpace
	VAR oFont                      // XbpFont
	VAR oFontnorm
	VAR oFontkursiv
	VAR oFontnkursiv
	VAR oFontnklein
	VAR oFontkklein
	VAR oFontnsmall
	VAR oFontnvsmall
	VAR oFontnsklein
	VAR oFontngross
	VAR oFontfett
	VAR oFontfklein
	VAR oFontfsmall
	VAR oFontfvsmall
	VAR oFontfsklein
	VAR oFontfgross
	VAR oFontfmgross
	VAR oFontfsgross
	VAR aViewPort                  // Viewport zum zoomen
	VAR aPageSize                  // Seitengre zum Drucken
	VAR aCharAttr                  // Attribute fr Strings (GRA_AS_BOX)
	VAR aAreaAttr                  // Attribute fr Flchen (GRA_AA_COLOR)
	VAR nPagePos                   // akt. Seitenposition
	VAR nRows                      // Anz. der Zeilen pro Seite
	VAR lquerformat								 // Ausrichtung in Querformat?

	METHOD setOrigin               // Ursprung fr Viewport setzen
	METHOD calcScrollBox           // Gre der ScrollBox bei Scrollbars berechnen

	METHOD startDoc                // Drucken beginnen
	METHOD endDoc                  // Drucken beenden

	EXPORTED:
	VAR hScroll    READONLY        // Horizontaler Scrollbar
	VAR vScroll    READONLY        // Vertikaler Scrollbar
	VAR oPagePos                   // Static zum Anzeigen der akt. Seitenposition
	VAR oNextPage                  // Button zum Anzeigen der naechsten Seite
	VAR oPrevPage                  // Button zum Anzeigen der vorigen Seite
																** Konfiguration
	VAR drawBlock                  // Codeblock ruft Func zum Zeichnen auf
	VAR printer                    // XbpPrinter
	VAR zoomFactor                 // Zoomfaktor von 1 bis n
	VAR segments                   // Array mit Segment IDs
																** Lebenszyklus
	METHOD init                    //
	METHOD create                  //
	METHOD destroy                 //
																** Anzeige
	METHOD setSize                 // Gre definieren
	METHOD hScroll                 // Horizontal scrollen
	METHOD vScroll                 // Vertical scrollen
	METHOD zoom                    // Zoomen
	METHOD presSpace               // Pesentation Space abfragen
	METHOD setViewPort             // Gre vom Viewport einstellen
	METHOD drawPage                // Zeichnen einer Seite
																** Drucken
	METHOD print                   // Ausgeben der Seiten auf dem Drucker

	METHOD numPages                // Ermitteln der Anzahl der Seiten
	METHOD pageNo                  // Ermitteln der Nummer der akt. Seite

	METHOD drawNextPage            // Zeichnen der nchsten Seite
	METHOD drawPrevPage            // Zeichnen der vorigen Seite
	METHOD gopage                  // Anspringen einer Seite
	METHOD showjumpedpage          // Zeichnen der angesprungenen Seite
ENDCLASS


/*
 * Viewport zoomen
 */
METHOD XbpPreview:zoom( nZoomFactor )

	 LOCAL aSize  := ::oView:drawingArea:currentSize()

	 if nZoomFactor == NIL
	 		nZoomFactor := ::zoomFactor
	 endif
   ::zoomFactor := Max( 1, nZoomFactor )

   // Viewport neu berechnen
   aSize[1] := Int( aSize[1] * nZoomFactor )
   aSize[2] := Int( aSize[2] * nZoomFactor )

   ::aViewPort  := {0,0,aSize[1],aSize[2]}
   ::calcScrollBox()

   // Ursprung vom Viewport neu definieren
   ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )

RETURN self

METHOD XbpPreview:gopage()
::anzeigseite := -1
AnsprungSeite():New( ::numPages(), SetAppWindow() ,self ):Create()

do while ::anzeigseite == -1
	inkey( 0.2 )
enddo

if ::anzeigseite > 0
	::showjumpedpage()
endif
return self

METHOD XbpPreview:showjumpedpage()
::nPagePos := ::anzeigseite
::drawPage()
::oPagePos:invalidateRect()
::anzeigseite := -1
return self

/*
 * Objekt initialisieren
 */
METHOD XbpPreview:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

	::xbpStatic:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
	::xbpStatic:type  := XBPSTATIC_TYPE_RAISEDRECT

	::oView           := XbpDialog():new( self )

	::vScroll         := XbpScrollbar():new( self )
	::vScroll:type    := XBPSCROLL_VERTICAL
	::vScroll:cargo   := 0
	::vScroll:autoTrack := .F.

	::oPagePos        := XbpPushButton():new( self )
	::oPagePos:activate := { || ::gopage() }

	::oNextPage       := XbpPushButton():new( self )
	::oNextPage:caption := "+"
	::oNextPage:activate := { || ::drawNextPage() }
	::oPrevPage       := XbpPushButton():new( self )
	::oPrevPage:caption := "-"
	::oPrevPage:activate := { || ::drawPrevPage() }

	::hScroll         := XbpScrollbar():new( self )
	::hScroll:type    := XBPSCROLL_HORIZONTAL
	::hScroll:cargo   := 0
	::hScroll:autoTrack := .F.

	::oSquare         := XbpStatic():new( self )
	::oSquare:type    := XBPSTATIC_TYPE_RECESSEDBOX

	// Initialisieren des Presentation Space fr die
	// Ausgabe der Vorschau. Um genaue Textausgabe
	// sicherzustellen, wird hier explizit der Modus
	// "hohe Textprzision" eingestellt
	::oPresSpace      := XbpPresSpace():new()
	::oPresSpace:mode := XBPPS_MODE_HIGH_PRECISION

	::zoomFactor      := 1
	::segments        := {}
	::nPagePos        := 1
	::nRows           := 0
	::lquerformat 		:= ( aSize[ 1 ] > aSize[ 2 ] )

	// Standard Drucker bereitstellen
	::printer         := XbpPrinter():new()

	// Beende Applikation wenn kein Drucker installiert ist.
	IF ::printer:list() == NIL
		ConfirmBox( , "Fehler - Es sind keine Drucker installiert!", ;
									"Seitenvorschau", ;
									XBPMB_OK, ;
									XBPMB_CRITICAL )
		QUIT
	ENDIF

RETURN self



/*
 * Systemresourcen anfordern
 */
METHOD XbpPreview:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
//   LOCAL oFont, i, imax, aFontList
local aSize2

   // XbpStatic ist Parent fr alle weiteren XBPs
   ::xbpStatic:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   // Printer erzeugen
   ::printer:create()
	::printer:SetFormSize( XBPPRN_FORM_A4 )
	if ::lquerformat
		::printer:SetOrientation( XBPPRN_ORIENT_LANDSCAPE )
	else
		::printer:SetOrientation( XBPPRN_ORIENT_PORTRAIT )
	endif

   // XbpDialog wird ohne Titel angezeigt
   ::oView:minButton := .F.
   ::oView:maxButton := .F.
   ::oView:sysMenu   := .F.
   ::oView:titleBar  := .F.
   ::oView:border    := XBPDLG_THINBORDER
   ::oView:create()

   ::oPagePos:create()
   ::oPagePos:setFontCompoundName( "7.Arial" )
   ::oPagePos:paint  := { || ::oPagePos:setCaption( AllTrim(Str(::pageNo())) +;
	                     "/" + AllTrim(Str(::numPages())) ) }

   ::oNextPage:create()
   ::oNextPage:setFontCompoundName( "7.Arial" )
   ::oPrevPage:create()
   ::oPrevPage:setFontCompoundName( "7.Arial" )

   // Scrollbars und Fllquadrat zw. Scrollbars erzeugen
   ::oSquare:create()
   ::hScroll:create()
   ::vScroll:create()

   ::hScroll:scroll := {|mp1| ::hScroll( mp1 ) }
   ::vScroll:scroll := {|mp1| ::vScroll( mp1 ) }

   // Gre der XBPs wird in :setSize() eingestellt
   ::setSize( ::currentSize() )

   // Gre der Druckseite abzglich nicht bedruckbarer Rnder berechnen
   // Die Einheit ist 1/10 mm
   aSize2       := ::printer:paperSize()
   ::aPageSize := { aSize2[5]-aSize2[3], aSize2[6]-aSize2[4] }

   // Presentation Space mit Drucker Device Context verknpfen
   // Der PS bekommt die metrische Einheit 1/10 mm
   ::oPresSpace:create( ::printer, ::aPageSize, GRA_PU_LOMETRIC )

   IF ::oFont == NIL
		::oFontnorm    := XbpFont():new( ::oPresSpace )
		::oFontnorm:FamilyName := "Arial"
		::oFontnorm:nominalPointSize := 10
		::oFontnorm:generic := .t.
		::oFontnorm:create()
		::oFontkursiv  := XbpFont():new( ::oPresSpace )
		::oFontkursiv:FamilyName := "Arial"
		::oFontkursiv:italic := .t.
		::oFontkursiv:nominalPointSize := 12
		::oFontkursiv:generic := .t.
		::oFontkursiv:create()
		::oFontnkursiv := XbpFont():new( ::oPresSpace )
		::oFontnkursiv:FamilyName := "Arial"
		::oFontnkursiv:italic := .t.
		::oFontnkursiv:nominalPointSize := 10
		::oFontnkursiv:generic := .t.
		::oFontnkursiv:create()
		::oFontnklein  := XbpFont():new( ::oPresSpace )
		::oFontnklein:FamilyName := "Arial"
		::oFontnklein:nominalPointSize := 9
		::oFontnklein:generic := .t.
		::oFontnklein:create()
		::oFontkklein  := XbpFont():new( ::oPresSpace )
		::oFontkklein:FamilyName := "Arial"
		::oFontkklein:italic := .t.
		::oFontkklein:nominalPointSize := 9
		::oFontkklein:generic := .t.
		::oFontkklein:create()
		::oFontnsmall  := XbpFont():new( ::oPresSpace )
		::oFontnsmall:FamilyName := "Arial"
		::oFontnsmall:nominalPointSize := 8
		::oFontnsmall:generic := .t.
		::oFontnsmall:create()
		::oFontnvsmall := XbpFont():new( ::oPresSpace )
		::oFontnvsmall:FamilyName := "Arial"
		::oFontnvsmall:nominalPointSize := 7
		::oFontnvsmall:generic := .t.
		::oFontnvsmall:create()
		::oFontnsklein := XbpFont():new( ::oPresSpace )
		::oFontnsklein:FamilyName := "Arial"
		::oFontnsklein:nominalPointSize := 6
		::oFontnsklein:generic := .t.
		::oFontnsklein:create()
		::oFontngross  := XbpFont():new( ::oPresSpace )
		::oFontngross:FamilyName := "Arial"
		::oFontngross:nominalPointSize := 14
		::oFontngross:generic := .t.
		::oFontngross:create()
		::oFontfett    := XbpFont():new( ::oPresSpace )
		::oFontfett:FamilyName := "Arial"
		::oFontfett:bold := .t.
		::oFontfett:nominalPointSize := 10
		::oFontfett:generic := .t.
		::oFontfett:create()
		::oFontfklein  := XbpFont():new( ::oPresSpace )
		::oFontfklein:FamilyName := "Arial"
		::oFontfklein:bold := .t.
		::oFontfklein:nominalPointSize := 9
		::oFontfklein:generic := .t.
		::oFontfklein:create()
		::oFontfsmall  := XbpFont():new( ::oPresSpace )
		::oFontfsmall:FamilyName := "Arial"
		::oFontfsmall:bold := .t.
		::oFontfsmall:nominalPointSize := 8
		::oFontfsmall:generic := .t.
		::oFontfsmall:create()
		::oFontfvsmall := XbpFont():new( ::oPresSpace )
		::oFontfvsmall:FamilyName := "Arial"
		::oFontfvsmall:bold := .t.
		::oFontfvsmall:nominalPointSize := 7
		::oFontfvsmall:generic := .t.
		::oFontfvsmall:create()
		::oFontfsklein := XbpFont():new( ::oPresSpace )
		::oFontfsklein:FamilyName := "Arial"
		::oFontfsklein:bold := .t.
		::oFontfsklein:nominalPointSize := 6
		::oFontfsklein:generic := .t.
		::oFontfsklein:create()
		::oFontfgross  := XbpFont():new( ::oPresSpace )
		::oFontfgross:FamilyName := "Arial"
		::oFontfgross:bold := .t.
		::oFontfgross:nominalPointSize := 14
		::oFontfgross:generic := .t.
		::oFontfgross:create()
		::oFontfmgross  := XbpFont():new( ::oPresSpace )
		::oFontfmgross:FamilyName := "Arial"
		::oFontfmgross:bold := .t.
		::oFontfmgross:nominalPointSize := 112
		::oFontfmgross:generic := .t.
		::oFontfmgross:create()
		::oFontfsgross  := XbpFont():new( ::oPresSpace )
		::oFontfsgross:FamilyName := "Arial"
		::oFontfsgross:bold := .t.
		::oFontfsgross:nominalPointSize := 168
		::oFontfsgross:generic := .t.
		::oFontfsgross:create()
		::oFont    := XbpFont():new( ::oPresSpace )
		::oFont:FamilyName := "Arial"
		::oFont:nominalPointSize := 10
		::oFont:generic := .t.
		::oFont:create()
   ENDIF

   // Beim Repaint wird alles mit einer weien Box bermalt
   ::aCharAttr := Array( GRA_AS_COUNT )
   ::aAreaAttr := Array( GRA_AA_COUNT )
   ::aAreaAttr [ GRA_AA_COLOR ] := GRA_CLR_WHITE
   ::oPresSpace:setAttrArea( ::aAreaAttr )

   ::oPresSpace:setFont( ::oFontnorm )

   // Beende Applikation, wenn kein Codeblock zugewiesen wurde
   IF ValType( ::drawBlock ) != "B"
      MsgBox( ":drawBlock ist ungltig!" )
      QUIT
   ENDIF

   // Evaluieren des Codeblocks in ":drawBlock" zum Formatieren
   // der ersten Seite. Dieser mu eine Routine aufrufen, die
   // die Anzeige durchfhrt, siehe Funktion "FormatPage()"
  AAdd( ::segments, Eval(::drawBlock, ::oPresSpace, NIL, @::segments) )
  ASize( ::segments, ::numPages() - 1 )
	if ::numPages() <= 1
	 ::oPagePos:Disable()
	 ::oNextPage:Disable()
	 ::oPrevPage:Disable()
	endif

   // Viewport initialisieren
   aSize2       := ::oView:drawingArea:currentSize()
   ::aViewPort := { 0, 0, aSize2[1], aSize2[2] }
   ::oView:drawingArea:paint := {|| ::drawPage() }
   // Presentation Space mit Window Device Context verkn?pfen
   ::oPresSpace:configure( ::oView:drawingArea:winDevice() )
   ::zoom()
	 ::oPresSpace:setFont( ::oFont )
	 ::oPresSpace:setAttrArea( ::aAreaAttr )
	 ::oPresSpace:setAttrString( ::aCharAttr )

RETURN self



/*
 * Systemresourcen freigeben
 */
METHOD XbpPreview:destroy
local nI, nJ
   ::xbpStatic:destroy()
   ::aViewPort := ;
   ::aPageSize := ;
   ::oFont     := NIL
  nJ := len( ::segments )
  for nI := 1 to nJ
		GraSegDestroy( ::presSpace(), ::segments[ nI ] )
	next

	if valtype(::opresSpace) == "O"
		::opresSpace:Destroy()
	endif

	::opresSpace := NIL
	::segments       := {}
RETURN self



/*
 * Gre von XbpStatic und enthaltenen XBPs ndern
 */
METHOD XbpPreview:setSize( aSize )

   ::xbpStatic:setSize( aSize )
   aSize := ::currentSize()

   ::oPagePos:setPos ( { 0, 0 } )
   ::oPagePos:setSize( { 40, 16 } )
   ::oNextPage:setPos ( { 40, 0 } )
   ::oNextPage:setSize( { 20, 16 } )
   ::oPrevPage:setPos ( { 60, 0 } )
   ::oPrevPage:setSize( { 20, 16 } )

   ::hScroll:setPos ( { 80, 0 } )
   ::hScroll:setSize( { aSize[1]-16-80, 16 } )
   ::vScroll:setPos ( { aSize[1]-16, 16 } )
   ::vScroll:setSize( { 16, aSize[2]-16 } )
   ::oSquare:setPos ( { aSize[1]-16,  0 } )
   ::oSquare:setSize( { 16, 16 } )
   ::oView  :setPos ( { 0 , 16 } )
   ::oView  :setSize( { aSize[1]-16, aSize[2]-16 } )

RETURN self



/*
 * Horizontal scrollen
 */
METHOD XbpPreview:hScroll( mp1 )
   LOCAL nScrollPos := mp1[1]
   LOCAL nCommand   := mp1[2]
   LOCAL nScroll

   IF (nScrollPos == 0                               .AND. ;
       ::hScroll:getData() == 0)                     .OR.  ;
      (nScrollPos == ::hScroll:setRange()[2]         .AND. ;
       ::hScroll:getData() == ::hScroll:setRange()[2] )
       RETURN self
   ENDIF

   DO CASE
   CASE nCommand == XBPSB_PREVPOS
      nScroll = ::hScroll:getData() - ::hScroll:setScrollBoxSize()
      ::hScroll:setData( Max(nScroll, 0) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPOS
      nScroll = ::hScroll:getData() + ::hScroll:setScrollBoxSize()
      ::hScroll:setData( Min(nScroll, ::hScroll:setRange()[2]) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_PREVPAGE
      ::hScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPAGE
      ::hScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_ENDTRACK
      ::hScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   ENDCASE

RETURN self



/*
 * Vertikal scrollen
 */
METHOD XbpPreview:vScroll( mp1 )
   LOCAL nScrollPos := mp1[1]
   LOCAL nCommand   := mp1[2]
   LOCAL nScroll

   IF (nScrollPos == 0                               .AND. ;
       ::vScroll:getData() == 0)                     .OR.  ;
      (nScrollPos == ::vScroll:setRange()[2]         .AND. ;
       ::vScroll:getData() == ::vScroll:setRange()[2] )
       RETURN self
   ENDIF

   DO CASE
   CASE nCommand == XBPSB_PREVPOS
      nScroll = ::vScroll:getData() - ::vScroll:setScrollBoxSize()
      ::vScroll:setData( Max(nScroll, 0) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPOS
      nScroll = ::vScroll:getData() + ::vScroll:setScrollBoxSize()
      ::vScroll:setData( Min(nScroll, ::vScroll:setRange()[2]) )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_PREVPAGE
      ::vScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_NEXTPAGE
      ::vScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   CASE nCommand == XBPSB_ENDTRACK
      ::vScroll:setData( nScrollPos )
      ::setOrigin( ::hScroll:getData(), ::vScroll:getData() )
   ENDCASE

RETURN self



/*
 * Ursprung vom Viewport setzen (nach Scrollen)
 */
METHOD XbpPreview:setOrigin( nX, nY )
   LOCAL aSize       := ::oView:drawingArea:currentSize()
   LOCAL nViewWidth  := aSize[1]
   LOCAL nViewHeight := aSize[2]
   LOCAL nZoomWidth  := nViewWidth  * ::zoomFactor
   LOCAL nZoomHeight := nViewHeight * ::zoomFactor

   // X Ursprung ist immer <= 0
   nX := - Abs( nX )

   IF nZoomWidth <= nViewWidth
      nX := 0
   ELSEIF nViewWidth - nX >= nZoomWidth
      nX := nViewWidth - nZoomWidth
   ENDIF

   ::aViewPort[1] := nX
   ::aViewPort[3] := nX + nZoomWidth

   // Y Ursprung ist immer <= 0
   // Es mu die Differenz zwischen Gesamthhe und
   // sichtbarem Bereich bercksichtigt werden
   nY := Abs( nY ) - ( nZoomHeight - nViewHeight )

   IF nY > 0 .OR. nZoomHeight <= nViewHeight
      nY := 0
   ELSEIF nViewHeight - nY >= nZoomHeight
      nY := nViewHeight - nZoomHeight
   ENDIF

   ::aViewPort[2] := nY
   ::aViewPort[4] := nY + nZoomHeight

   ::setViewPort( ::aViewPort )
   ::drawPage()

RETURN self



/*
 * Gre der ScrollBox und Range fr beide Scrollbars berechnen
 */
METHOD XbpPreview:calcScrollBox()
   LOCAL aSize       := ::oView:drawingArea:currentSize()
   LOCAL nViewWidth  := aSize[1]
   LOCAL nViewHeight := aSize[2]
   LOCAL nZoomWidth  := aSize[1] * ::zoomFactor
   LOCAL nZoomHeight := aSize[2] * ::zoomFactor

   // Werte fr horizontalen Scrollbar berechnen
   ::hScroll:setRange( { 0, Int(nZoomWidth - nViewWidth) } )
   IF nZoomWidth > nViewWidth
      ::hScroll:setScrollBoxSize( (nZoomWidth-nViewWidth) * (nViewWidth/nZoomWidth) )
   ELSE
      ::hScroll:setScrollBoxSize( nViewWidth )
   ENDIF

   // Werte fr vertikalen Scrollbar berechnen
   ::vScroll:setRange( { 0, Int(nZoomHeight - nViewHeight) } )
   IF nZoomHeight > nViewHeight
      ::vScroll:setScrollBoxSize( (nZoomHeight-nViewHeight) * (nViewHeight/nZoomHeight) )
   ELSE
      ::vScroll:setScrollBoxSize( nViewHeight )
   ENDIF

RETURN self




/*
 * Presentation Space abfragen
 */
METHOD XbpPreview:presSpace
RETURN ::oPresSpace



/*
 * Viewport setzen
 */
METHOD XbpPreview:setViewPort( aViewPort )
   LOCAL aOldViewPort := ::oPresSpace:setViewPort()

   IF Valtype( aViewPort ) == "A"
      ::aViewPort := aViewPort
      ::oPresSpace:setViewPort( aViewPort )
   ENDIF
RETURN aOldViewPort



/*
 * Zeichnen der angegebenen Seite
 */
METHOD XbpPreview:drawPage( nPageNo )

   if nPageNo == NIL
   		nPageNo := ::nPagePos
   endif

   IF Len(::segments) == 0
      RETURN self
   ENDIF

   // Zeichnung wird durch Ausgabe einer wei gefllten Box gelscht
   GraBox( ::oPresSpace, {0,0}, ::aPageSize, GRA_FILL )

   IF nPageNo != 0 .AND. nPageNo <= ::numPages()
      IF ::segments[nPageNo] == NIL
	 ::segments[nPageNo] := Eval( ::drawBlock,  ;
	                              ::oPresSpace, ;
	                              nPageNo, ;
	                              @::segments )
      ENDIF

      IF ::segments[nPageNo] != 0
	 GraSegDraw( ::presSpace(), ::segments[nPageNo] )
      ENDIF
   ENDIF

RETURN self



/*
 * Druckausgabe beginnen
 * - Der Presentation Space wird mit dem Print Device Context assoziiert
 */
METHOD XbpPreview:startDoc( cTitle )

	::oPresSpace:configure( ::printer )

	// Ab jetzt wird die Ausgabe in :oPresSpace auf den Spooler umgeleitet
	::printer:startDoc( cTitle )
	vorschau := .f.
	// Font und Attribute gehen nach :configure() verloren -> neu setzen
	::oPresSpace:setFont( ::oFont )
	::oPresSpace:setAttrArea( ::aAreaAttr )
	::oPresSpace:setAttrString( ::aCharAttr )

RETURN self



/*
 * Druckausgabe beenden
 * - Der Presentation Space wird wieder mit dem Window Device Context assoziiert
 */
METHOD XbpPreview:endDoc

	// Spooler schlieen
	::printer:endDoc()

	// PS wieder mit Window Device verknpfen
	::oPresSpace:configure( ::oView:drawingArea:winDevice() )
	vorschau := .t.
	// Font und Attribute gehen nach :configure() verloren -> neu setzen
	::oPresSpace:setFont( ::oFont )
	::oPresSpace:setAttrArea( ::aAreaAttr )
	::oPresSpace:setAttrString( ::aCharAttr )

	// Viewport fr Window setzen
	::zoom()

RETURN self



/*
 * Ausgabe aller Seiten auf dem Drucker
 */
METHOD XbpPreview:print( alle, Title, datsaetze, dbname )
	LOCAL i

	IF Len(::segments) == 0
		RETURN self
	ENDIF

	::startDoc( Title )
	if alle
		FOR i:=1 TO ::numPages()
			::drawPage( i )
			if datsaetze <> NIL
				if i <= len( datsaetze )
					( dbname )->(Dbgoto( datsaetze[ i ] ) )
					( dbname )->gedruckt := .t.
				endif
			endif
			IF i +1 <= ::numPages()
				::printer:newPage()
			ENDIF
		NEXT
		if datsaetze <> NIL
			( dbname )->( DbCommitAll() )
		endif
	else
		::drawPage( ::nPagePos )
		if datsaetze <> NIL
			if ::nPagePos <= len( datsaetze )
				( dbname )->(Dbgoto( datsaetze[ ::nPagePos ] ) )
				( dbname )->gedruckt := .t.
				( dbname )->( DbCommitAll() )
			endif
		endif
	endif

	::endDoc()

RETURN self


/*
 * Ermitteln der Seitenanzahl
 */
METHOD XbpPreview:numPages()
RETURN len( ::segments )

/*
 * Ermitteln der Nummer der akt. Seite
 */
METHOD XbpPreview:pageNo()
RETURN ::nPagePos
/*
 * Anzeigen der nchsten Seite
 */
METHOD XbpPreview:drawNextPage()
   IF ::nPagePos +1 <= ::numPages()
      ::nPagePos++
      ::drawPage()
      ::oPagePos:invalidateRect()
   ENDIF
RETURN self

/*
 * Anzeigen der vorhergehenden Seite
 */
METHOD XbpPreview:drawPrevPage()
   IF ::nPagePos -1 > 0
      ::nPagePos--
      ::drawPage()
      ::oPagePos:invalidateRect()
   ENDIF
RETURN self

#ifndef _AnsprungSeite_
#define _AnsprungSeite_

*+
*+
*+    Class _AnsprungSeite
*+
*+
*+
//  Enthaltene Kontrollelemente
class _AnsprungSeite from xbpDialog

  exported:
    var editControls

    var Static1
    var Static2
    var einnr
    var maxs
    var ButtonCancel
    var ButtonOK
		var lAbbruch

    method init
    method create
		method auslesen
		method abbruch
endclass

method _AnsprungSeite:abbruch( oOwner )
	::lAbbruch := .f.
	::setModalState( XBP_DISP_MODELESS )
	oOwner:anzeigseite := 0
	oOwner:invalidaterect()
	SetAppFocus( oOwner )
	::xbpDialog:Destroy()
return self

method _AnsprungSeite:auslesen( oOwner )
	if ( val( ::einnr:EditBuffer() ) > 0 ) .and. ( val( ::einnr:EditBuffer() ) <= ::maxs )
		::lAbbruch := .f.
		::setModalState( XBP_DISP_MODELESS )
		oOwner:anzeigseite := val( ::einnr:EditBuffer() )
		oOwner:invalidaterect()
		SetAppFocus( oOwner )
		::xbpDialog:Destroy()
	else
		MsgBox("Ungltige Seitenzahl!")
	endif
return self

// *****************************************************************************
//  Formular initialisieren
// *****************************************************************************

*+
*+
*+    Method _AnsprungSeite:init()
*+
*+
*+
method _AnsprungSeite:init( maxseiten, oParent, oOwner, aPos, aSize, aPP, lVisible )

if valtype( aPP ) == "U"
	aPP := {}
endif
aadd( aPP, { XBP_PP_BGCLR, GRA_CLR_PALEGRAY } )
aadd( aPP, { XBP_PP_FGCLR, GRA_CLR_BLACK } )
aadd( aPP, { XBP_PP_COMPOUNDNAME, "10.Arial" } )
		::maxs := maxseiten
		allesok := .t.
//{ 240, 150 }
		::xbpDialog:init( oParent, oOwner, {100,100}, ,aPP, .F. )
		//   obDlg:border    := XBPDLG_RAISEDBORDERTHIN_FIXED
		::xbpDialog:clientSize := { 240, 125 }
		::xbpDialog:close := { || iif( ::lAbbruch, ::abbruch(), ) }
		::xbpDialog:border    := XBPDLG_RAISEDBORDERTHICK_FIXED
		::xbpDialog:maxButton := .F.
		::xbpDialog:titleBar  := .T.
 		::xbpDialog:title     := "Seitenzahl eingeben"

		::editcontrols := {}
		::lAbbruch := .t.

		::Static1      := xbpStatic():new( ::drawingArea, , {16,50}, {200,50} )
		::Static1:caption := ""
		::Static1:clipSiblings := .T.
		::Static1:type := XBPSTATIC_TYPE_RECESSEDBOX

		::Static2      := xbpStatic():new( ::drawingArea, , {32,63}, {100,24} )
		::Static2:caption := "Seite:"
		::Static2:clipSiblings := .T.
		::Static2:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_WORDBREAK

		::einnr := xbpSLE():new( ::drawingArea, , {150, 67}, {50, 18} )
		::einnr:bufferLength := 5
		::einnr:clipSiblings := .T.
    aadd( ::editControls, ::einnr )

		::ButtonOK         := xbpPushButton():new( ::drawingArea,, { 16, 13 }, { 90, 24 } )
		::ButtonOK:caption := "OK"
 		::ButtonOK:activate := { || ::auslesen( oOwner )}

		::ButtonCancel         := xbpPushButton():new( ::drawingArea,, { 126, 13 }, { 90, 24 } )
		::ButtonCancel:caption := "Abbruch"
		::ButtonCancel:activate := { || ::abbruch( oOwner ) }

return self

// *****************************************************************************
//  Systemresourcen anfordern
// *****************************************************************************

*+
*+
*+    Method _AnsprungSeite:create()
*+
*+
*+
method _AnsprungSeite:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

::xbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
::static1:create()
::static2:create()
::einnr:create()
::ButtonOK:create()
::ButtonCancel:create()

return self

#endif

// *****************************************************************************
//  Formular initialisieren
// *****************************************************************************

*+
*+
*+    Class AnsprungSeite
*+
*+
*+
//  Enthaltene Kontrollelemente
class AnsprungSeite from _AnsprungSeite

	exported:

    method init
    method create
endclass

*+
*+
*+    Method AnsprungSeite:init()
*+
*+
*+
method AnsprungSeite:init( maxseiten, oParent, oOwner, aPos, aSize, aPP, lVisible )

if valtype( aPP ) == "U"
	aPP := {}
endif

::_AnsprungSeite:init( maxseiten, oParent, oOwner, aPos, aSize, aPP, lVisible )

return self

/*
 * Systemresourcen anfordern
 */

*+
*+
*+    Method AnsprungSeite:create()
*+
*+
*+
method AnsprungSeite:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

::_AnsprungSeite:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
//  Formular anzeigen
::ShowModal()

return self

PROCEDURE AppSys()
// Wird hier nicht bentigt
RETURN

PROCEDURE Main
   LOCAL nEvent, mp1, mp2
   LOCAL oDlg, oXbp, drawingArea, oView

   SET DEFAULT TO "..\..\DATA"
   USE Cars NEW

   oDlg := XbpDialog():new( SetAppWindow(), , {100,100}, {800,925}, , .F.)
   
   oDlg:border    := XBPDLG_RAISEDBORDERTHICK_FIXED
   oDlg:title     := "Vorschau-Dialog"
   oDlg:minButton := .F.
   oDlg:maxButton := .F.
   oDlg:taskList  := .T.
   oDlg:create()

   drawingArea := oDlg:drawingArea
   drawingArea:setFontCompoundName( "8.Helv" )

// A4-Fomrat ist 210*297 - hier jeweils das Dreifache als Gre, um das Seitenverhltnis beizubehalten
   oView := XbpPreview():new( drawingArea, , {0,0}, {630,891} )
   oView:drawBlock := {|oPS, nPageNo, segments| FormatPage(oPS, nPageNo, @segments) }
   oView:create()

   oXbp := XbpPushButton():new( drawingArea, , {683,325}, {100,30} )
   oXbp:caption := "Zoom ++"
   oXbp:activate := {|| oView:zoom( oView:zoomFactor + 0.25 ) }
   oXbp:create()

   oXbp := XbpPushButton():new( drawingArea, , {683,275}, {100,30} )
   oXbp:caption := "Zoom - -"
   oXbp:activate := {|| oView:zoom( oView:zoomFactor - 0.25 ) }
   oXbp:create()

   oXbp := XbpPushButton():new( drawingArea, , {683,225}, {100,30} )
   oXbp:caption := "Drucken (akt.)"
	 oXbp:activate := { || oView:print( .f., "Drucken: Aktuelle Seite" ) }
   oXbp:create()
	
	 oXbp := XbpPushButton():new( drawingArea,, { 683, 175 }, { 100, 30 } )
   oXbp:caption := "Drucken (komp.)"
	 oXbp:activate := { || oView:print( .t., "Drucken: komplettes Dokument" ), PostAppEvent( xbeP_Close ) }
   oXbp:create()

	 oXbp := XbpPushButton():new( drawingArea,, { 683, 125 }, { 100, 30 } )
   oXbp:caption := "Druckersetup"
	 oXbp:activate := { || oView:Printer:setupDialog(), oView:invalidateRect() }
   oXbp:create()

   oXbp := XbpPushButton():new( drawingArea, , {683,75}, {100,30} )
   oXbp:caption := "OK"
   oXbp:activate := {|| PostAppEvent( xbeP_Close ) }
   oXbp:create()

   oDlg:show()
   SetAppFocus( oXbp )

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
RETURN



/*
 * Funkion zum Formatieren einer Seite fr die Vorschau. Diese
 * wird ber den ":drawBlock" Codeblock aufgerufen und bekommt
 * drei Parameter [bergeben. "oPS" ist der Presentation Space
 * in den gezeichnet werden soll. Parameter "nPageNo" bestimmt
 * die Seite, die fr den Preview formatiert werden soll.
 * "nNumRows" gibt die Anzahl der Zeilen pro Seite an und wird
 * zur Positionierung des Datenbank-Cursors fr Seiten ungleich
 * der ersten Seite bentigt. Fr die erste Seite ("nPageNo"
 * == 1) mu diese von der Funktion berechnet und zurckgegeben
 * werden. Die Rekordnummer, ab der aus der Datenbank gelesen
 * werden soll, ergibt sich fr Seitennummern grer 1 aus
 * 
 *   nRecNo := ((nPageNo -1) * nNumRows) +1
 *
 * Rckgabewert ist ein grafisches Segment mit den grafischen
 * Primitiven, die zum Anzeigen der Seite ntig sind.
 * 
 * Hinweis zur Seitenformatierung und Anzeige:
 *   Die grafischen Primitiven zum Zeichnen der einzelnen
 *   Seiten werden jeweils in einem grafischen Segment gespei-
 *   chert. Diese werden jeweils [ber die Evaluierung des
 *   ":drawBlock" Codeblocks angefordert. Die Segmente werden
 *   dann entweder im Preview-Fenster zum Anzeigen der Vorschau
 *   oder auf dem Drucker abgespielt, um die entsprechende Seite
 *   darzustellen
 */
FUNCTION FormatPage( oPS, nPageNo, segments )
   LOCAL i, imax   := FCount()
   LOCAL aFields   := DbStruct()
   LOCAL aPageSize := oPS:setPageSize()[1]
   LOCAL aPosX[imax], nY, xValue
   LOCAL nFontWidth, nFontHeight
   LOCAL nSegment, oFontnorm

if nPageNo == NIL
	 oFontnorm    := XbpFont():new( oPS )
	 oFontnorm:FamilyName := "Arial"
	 oFontnorm:nominalPointSize := 10
	 oFontnorm:generic := .t.
	 oFontnorm:create()
	 GraSetFont( oPS, oFontnorm )
   // Maximale Hhe und Breite eines Buchstabens
   // im aktuellen Font feststellen
	 aTextBox    := GraQueryTextBox( oPS, "^g" )
	 nFontHeight := aTextBox[ 3, 2 ] - aTextBox[ 2, 2 ]
	 nFontWidth  := aTextBox[ 3, 1 ] - aTextBox[ 2, 1 ]

   aPosX[1]    := nFontWidth/2
   FOR i:=2 TO imax
      aPosX[i] := aPosX[i-1] + nFontWidth/2 + ;
                  Max( Len(aFields[i-1,1]),aFields[i-1,3] ) * nFontWidth
   NEXT

   // Anzeige der grafischen Primitiven whrend der Berechnung 
   // der Seiten unterdrcken
   GraSegDrawMode( oPS, GRA_DM_RETAIN )

	 nY := aPageSize[2] - 2 * nFontHeight

   //
   // Berechnung der Seite
   //
   // ffne neues Segment 
   nSegment := GraSegOpen( oPS )

   DO WHILE ( nY >= ( nFontHeight + 2 ) ) .and. ( .not. eof() )
   		if ( nY == aPageSize[2] - 2 * nFontHeight )
				 // Feldnamen und Spaltentrennlinien zeichnen
				 FOR i:=1 TO imax
						GraStringAt( oPS, { aPosX[i], nY }, FieldName(i) )
						GraLine( oPS, {aPosX[i]-nFontWidth/4, 0}, {aPosX[i]-nFontWidth/4, aPageSize[2]} )
				 NEXT

				 // Trennlinie fr Kopfzeile zeichnen
				 nY -= nFontHeight/2
				 GraLine( oPS, {0, nY}, {aPageSize[1], nY} )
			endif
				 // Seite mit Daten vollschreiben
      nY -= ( nFontHeight + 2 )

      FOR i := 1 TO imax
         xValue := FieldGet(i)
         DO CASE
            CASE aFields[i,2] == "D"
               xValue := DtoC( xValue )
            CASE aFields[i,2] == "L"
               xValue := IIf( xValue, "T", "F" )
            CASE aFields[i,2] == "M"
               xValue := Left( xValue, 10 )
            CASE aFields[i,2] == "N"
               xValue := Str( xValue )
         ENDCASE

         GraStringAt( oPS, { aPosX[i], nY }, xValue )
      NEXT

      SKIP      
      IF ( nY < ( nFontHeight + 2 ) ) .and. ( .not. Eof() )
				GraSegClose( oPS )
				aadd( segments, nSegment )
		    nY := aPageSize[2] - 2 * nFontHeight
				nSegment := GraSegOpen( oPS )
      ENDIF
   ENDDO

   // Schliee Segment und zurcksetzen des
   // Segment Drawing Mode
   GraSegClose( oPS )
   
   GraSegDrawMode( oPS, GRA_DM_DRAWANDRETAIN )
	 aadd( segments, nSegment )

	 nSegment := NIL
else
	 nSegment := segments[ nPageNo ]
endif

RETURN nSegment